/*
  Copyright (c) 2009 Yahoo! Inc. 
  All Rights Reserved
*/
function MusicUpdatesConsumesYahooUpdates() {
    var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
                     getService(Components.interfaces.mozIJSSubScriptLoader);
    if (scriptLoader) {
       scriptLoader.loadSubScript("chrome://foxytunes/content/utils.js");
       scriptLoader.loadSubScript("chrome://foxytunes/content/utils/json_parse_state.js");
       scriptLoader.loadSubScript("chrome://foxytunes/content/utils/oauth/oauthUtils.js");
    }

    FTJSLib.include(FTJSLib.jslib_uuid);
    this.uuidUtils = new FTJSLib.UUID();

    // Calling httprequest with timer because the call is initiated from a window
    // and when the window closes it creates a problem to httprequest 
    this._httpRequestTimer = Components.classes["@mozilla.org/timer;1"].
				                 		createInstance(Components.interfaces.nsITimer); 

    this._propertiesObj = {};
    this._IFTMusicConsumer = Components.interfaces.IFoxyTunesMusicConsumer;

    this._apiKey = 'dj0yJmk9YkptOFA2WHBXNlhQJmQ9WVdrOVMwOXFhM0kwTkhNbWNHbzlNakV4TmpnM05UYzVOZy0tJnM9Y29uc3VtZXJzZWNyZXQmeD00Mw--';
	this._appID = 'KOjkr44s';
    
    this._userGUID = null;
    this._userName = null;

    this._recursiveRefreshProtection = false;

    this._oauthUtils = new OAuthUtils(this._apiKey, 'yahooupdates');
    this._oauthUtils.setBaseURL('https://api.login.yahoo.com/oauth/v2/');
    this._oauthUtils.setUrlEndPoints({'request_token': 'get_request_token', 'access_token': 'get_token', 'auth_url': 'request_auth'});

    this._baseURL = 'http://social.yahooapis.com/v1/';
    this._apiResponseFormat = 'json';

    this.homepageRegExp =  new RegExp('^http:\\/\\/[\\w\\.]*yahoo\\.com\\/');

    this.SetProperty('readableName', 'Yahoo! Status');
    this.SetProperty('readableNameManual', 'Yahoo! Status');
    this.SetProperty('readableNameAuto', 'Yahoo! Updates');
    this.wrappedJSObject = this;
}

MusicUpdatesConsumesYahooUpdates.prototype = {
    classID : Components.ID("{E0F7F5F0-4C8C-11DE-8DD2-D8D356D89593}"),

    init: function() {}, 
    uninit: function () {},

    OnPlaybackUpdate: function(eventType, trackData, plainText, formattedText, link) {
       if (eventType != this._IFTMusicConsumer.EVENT_TRACK_PLAYING) return;

       var trackDataArr = trackData.split('\t');
        var trackDataObj = {};
        for (var i=0; i<trackDataArr.length-1; i+=2) {
            trackDataObj[trackDataArr[i]] = trackDataArr[i+1];
        }

        var me = this;
        var GuidCB = function(resp) {
            if (me._oauthUtils.isOAUTHReturnedError(resp)) {
                return;
            }
            me._userGUID = resp[0].guid.value;
            me.sendSongPlay(trackDataObj, link);
        }
        if (!this._userGUID) {
            this.getUserGUID(GuidCB);
        } else {
            this.sendSongPlay(trackDataObj, link);
        }
    },

    OnPlaybackStopped: function() {
        throw Components.results.NS_ERROR_NOT_IMPLEMENTED; 
    },

    SetUserAuth: function(userName, authDetails) {
        this._userName = userName;
        var tmpArr = authDetails.split('\t');
        var authDetails = {
            "accessToken": tmpArr[0],
            "accessTokenSecret": tmpArr[1],
            "verifier": tmpArr[2],
            "sessionHandle": tmpArr[3]
        }
        this._oauthUtils.setAuthDetails(authDetails);
    },

    SendMusicUpdate: function(trackData, plainText, formattedText, link) {
        var me = this;
        var GuidCB = function(resp) {
            if (me._oauthUtils.isOAUTHReturnedError(resp)) return;
            if (!resp[0]) return;

            me._userGUID = resp[0].guid.value;
            me.updateUserStatus(plainText);
        }

        var sendHttpRequestOnTimer = {
            notify: function (aTimer) {
                if (aTimer != me._httpRequestTimer) return;
        if (!this._userGUID) {
                    me.getUserGUID(GuidCB); 
        } else {
                    me.updateUserStatus(plainText);
        }
            }
        };

        this._httpRequestTimer.initWithCallback(sendHttpRequestOnTimer, 1000, Components.interfaces.nsITimer.TYPE_ONE_SHOT); 
    },

    SendGenericUpdate: function(topic, arguments) {
        throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
    },

    GetAuthWindowURL:function() {
        return 'chrome://foxytunes/content/music-updates/auth-windows/yahooUpdates.xul';
    },

    IsInstalled: function() {
        return true;
    },

    IsRunning: function() {
        var win = foxytunesGetMostRecentBrowserWindow();
        if (!win) return false; 

        try {
            var tabBrowser = win.getBrowser();
            var doc = tabBrowser.contentDocument;

            if (doc.location.href.match(this.homepageRegExp)) {
                return true;
            }
        } catch(e) {}
        
        return false;
    },

    RunService: function() {
        throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
    }, 

    GetCapabilities: function() {
        return (this._IFTMusicConsumer.CONSUMER_SUPPORT_MANUAL_UPDATES | 
                this._IFTMusicConsumer.CONSUMER_SUPPORT_AUTO_UPDATES |
                this._IFTMusicConsumer.CONSUMER_REQUIRES_AUTH);
    },

    SetProperty: function(propertyName, propertyValue) {
        this._propertiesObj[propertyName] = propertyValue;
    },

    GetProperty: function(propertyName) {
        return this._propertiesObj[propertyName];
    },

    SetProperties: function(propertyList) {
        throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
    },

    GetProperties: function() {
        throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
    },

    // Private
    onAccessTokenRefresh: function(resp, originalRequestObj) {
        if (this._oauthUtils.isOAUTHReturnedError(resp)) {
            this._recursiveRefreshProtection = false;
            return;
        }

        var oldAuthDetails = this._oauthUtils.getAuthDetails(["verifier"]);
        var authDetailsArr = [];
        authDetailsArr.push(resp["oauth_token"]);
        authDetailsArr.push(resp["oauth_token_secret"]);
        authDetailsArr.push(oldAuthDetails["verifier"]);
        authDetailsArr.push(resp["oauth_session_handle"]);
        var authDetailsStr = authDetailsArr.join('\t');

        var musicUpdatesService = Components.classes["@foxytunes.org/FoxyTunesEngine/FoxytunesMusicUpdatesService;1"]
                                              .getService().wrappedJSObject; 
        musicUpdatesService.removeConsumerAuthDetails('yahooupdates');
        musicUpdatesService.setConsumerAuthDetails('yahooupdates', this._userName, authDetailsStr);
        this.SetUserAuth(this._userName, authDetailsStr);

        if (typeof originalRequestObj != 'undefined') {
        this.callUpdatesAPI(originalRequestObj.request, originalRequestObj.callback);
        }

        this._recursiveRefreshProtection = false;
    },

    callUpdatesAPI: function(request, callback) {
        if (!request.path || !request.method) return;

        var me = this;
        var apiCallback = function(xmlHTTPrequest) {
            var contentsArr;
            if (xmlHTTPrequest.status != 200) {
                var responseHeader = xmlHTTPrequest.getResponseHeader("WWW-Authenticate");
                if (responseHeader && responseHeader.match('token_expired')) {
                    if (!me._recursiveRefreshProtection) {
                        me._recursiveRefreshProtection = true;
                        me._oauthUtils.getAccessToken(function(resp) { me.onAccessTokenRefresh(resp, {"request": request, "callback": callback}); }, true);
                    }
                    }
                contentsArr = {};
                contentsArr.error_code = xmlHTTPrequest.status;
                contentsArr.error_msg = xmlHTTPrequest.responseText;
            } else {
                contentsArr = json_parse('[' + xmlHTTPrequest.responseText + ']');
                }

            if (callback) callback(contentsArr);
        }
        var url = this._baseURL + request.path + '?format=' + this._apiResponseFormat;
        var signedURL = this._oauthUtils.getAPIURL(request.method, url); 
        foxytunesHTTPRequest({'method': request.method, 'url': signedURL, 'params': request.params}, apiCallback);
    },

    getUserGUID: function(callback) {
        this.callUpdatesAPI({'method': "GET", 'path': "me/guid"}, callback);
    },

    getTinyUserCard: function(callback) {
        var me = this;
        var GuidCB = function(resp) {
            if (me._oauthUtils.isOAUTHReturnedError(resp)) {
                if (callback) callback(resp);
                return;
            }
            me._userGUID = resp[0].guid.value;
            me.callUpdatesAPI({'method': "GET", 'path': "user/" + encodeURIComponent(me._userGUID) + "/profile/tinyusercard"}, callback);
        }
        this.getUserGUID(GuidCB);
    },

    updateUserStatus: function(status) {
        var params = '{"starttime": "' + new Date() + '", "endtime": "",  "status": "' + status + '"}';
        this.callUpdatesAPI({'method': "PUT", 'path': 'user/' + encodeURIComponent(this._userGUID) + '/presence/presence', 'params': params});
    },

    sendSongPlay: function(trackData, link) {
        suid = this.uuidUtils.uuidgen();
        var params = '{"updates":[{"class":"app","suid":"' + suid + '","link":"' + link + '","source":"APP.' + this._appID + '","pubDate":"' + Math.round(new Date().getTime() / 1000) + '","title":"' + trackData.title + '","type":"songplay","collectionType":"guid","collectionID":"' + this._userGUID + '"';
        if (trackData.artist) {
            var artistURL = link.match('.*foxytunes.com/artist/[^\/]+')[0];
            params += ', "artisttxt":"' + trackData.artist + '" , "artisturl":"' + artistURL + '"';
        }
        params += '}]}';

        this.callUpdatesAPI({'method': "PUT", 'path': 'user/' + encodeURIComponent(this._userGUID) + '/updates/APP.' + this._appID + "/" + suid , 'params': params});
    },

    // nsISupports
    QueryInterface: function (iid) {
        if (iid.equals(Components.interfaces.IFoxyTunesMusicConsumer) ||
			iid.equals(Components.interfaces.nsISupports)) {
               return this;
    }

	   throw Components.results.NS_ERROR_NO_INTERFACE;       
}
}

try {
    Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
    const NSGetFactory = XPCOMUtils.generateNSGetFactory([MusicUpdatesConsumesYahooUpdates]);
} catch (e) {};
