/*
  Copyright (c) 2009 Yahoo! Inc. 
  All Rights Reserved
*/
var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
                     getService(Components.interfaces.mozIJSSubScriptLoader);

if (scriptLoader) {
    scriptLoader.loadSubScript("chrome://foxytunes-components-js/content/players/FoxyTunesJSPlayerBase.js");
}

var playerConfig = new FoxyTunesJSPlayerConfig();
playerConfig.playerURLRegExp = new RegExp("blip.fm");
playerConfig.playerHomepage = "http://www.blip.fm/";
playerConfig.bUseGlobalVolumeController = true;
playerConfig.bUseChromeToContentBridge  = false;

playerConfig.commandStrMappings["Play"] = "dPlay";
playerConfig.commandStrMappings["Pause"] = "dPlay";
playerConfig.commandStrMappings["Next"] = "dNext";
playerConfig.commandStrMappings["Previous"] = "dPrev";

function FoxyTunesBlipFmController() {
    this.init(playerConfig);
}

FoxyTunesBlipFmController.prototype = new FoxyTunesJSPlayerBase();
FoxyTunesBlipFmController.prototype.classID = Components.ID("{55ECB1AA-8209-11DE-BE2D-CE5056D89593}");

FoxyTunesBlipFmController.prototype.defaultCmdHandler = function(player, cmd, value) {
    if (!player) return false;

    return this.clickElement(player, cmd);
};

FoxyTunesBlipFmController.prototype.GetCurrentTrackLength   = function() { throw Components.results.NS_ERROR_NOT_IMPLEMENTED; };
FoxyTunesBlipFmController.prototype.GetCurrentTrackPosition = function() { throw Components.results.NS_ERROR_NOT_IMPLEMENTED; };
FoxyTunesBlipFmController.prototype.SetCurrentTrackPosition = function() { throw Components.results.NS_ERROR_NOT_IMPLEMENTED; };
FoxyTunesBlipFmController.prototype.Stop = function() { return this.Pause(); };

FoxyTunesBlipFmController.prototype.commandHandlers["GetCurrentTrackTitle"] = function(player, cmd, value) {
    if (!player) return this.getTrackData();

    var title = this.getElementText(player.doc, 'nowplaying');
    if (!title) return this.getTrackData();

    var titleArr = title.split(':');
    titleArr.shift();
    title = titleArr.join(':');

    return this.getTrackData({"title": title, "isVideo": "no"});
};

FoxyTunesBlipFmController.prototype.playerIsPlayingInDoc = function(doc) {
    return (this.getElementText(doc, 'dPlay') == "pause");
};

FoxyTunesBlipFmController.prototype.clickElement = function(player, id) {
    var doc = player.doc;
    var el =  doc.getElementById(id);
    if (!el) return false;

    var evt = doc.createEvent("MouseEvents");
    evt.initMouseEvent("click", true, true, player.window, 0, 0, 0, 0, 0, 
                       false, false, false, false, 0, null);
    return el.dispatchEvent(evt);
};

FoxyTunesBlipFmController.prototype.getElementText = function(doc, id) {
    var el =  doc.getElementById(id);
    if (!el) return null;
        
    return el.textContent;
}

try {
    const NSGetFactory = XPCOMUtils.generateNSGetFactory([FoxyTunesBlipFmController]);
} catch(e) {};
