/*
  Copyright (c) 2009 Yahoo! Inc. 
  All Rights Reserved
*/
var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
                     getService(Components.interfaces.mozIJSSubScriptLoader);

if (scriptLoader) {
       scriptLoader.loadSubScript("chrome://foxytunes-components-js/content/players/FoxyTunesJSPlayerBase.js");
}

var playerConfig = new FoxyTunesJSPlayerConfig();
playerConfig.playerURLRegExp = new RegExp("deezer.com");
playerConfig.playerHomepage = "http://www.deezer.com/";
playerConfig.commandStrMappings["Play"] = "play();";
playerConfig.commandStrMappings["Pause"] = "pause();";
playerConfig.commandStrMappings["Next"] = "nextSong();";
playerConfig.commandStrMappings["Previous"] = "prevSong();";
playerConfig.commandStrMappings["SetVolume"] = "setVolume(%value%);";
playerConfig.commandStrMappings["GetVolume"] = "getVolume();";
playerConfig.commandStrMappings["Stop"] = "stop();";
playerConfig.commandStrMappings["IsMuted"] = "isMuted();";

function FoxyTunesDeezerController() {
    this.init(playerConfig);
}

FoxyTunesDeezerController.prototype = new FoxyTunesJSPlayerBase();
FoxyTunesDeezerController.prototype.classID = Components.ID("{28224D0C-7D54-11DE-9872-546F56D89593}");

FoxyTunesDeezerController.prototype.processCmdInput["SetVolume"] = function(value) { return value/100; };
FoxyTunesDeezerController.prototype.processCmdOutput["GetVolume"] = function(value) { return Math.round(value*100); };
FoxyTunesDeezerController.prototype.processCmdOutput["IsMuted"] = function(value) { return (value == "true") };

FoxyTunesDeezerController.prototype.defaultCmdHandler = function(player, cmd, value) {
    if (!player) return false;
    var deezerCmd = "deezerAudioJSPlayer." + cmd;
    return this.chromeToContentBridge.fireCommand(player.doc, deezerCmd);
};

FoxyTunesDeezerController.prototype.commandHandlers["ToggleMute"] = function(player, cmd, value) {
    if (!player) return false;
    this.chromeToContentBridge.fireCommand(player.doc, "deezerAudioJSPlayer.mute(" + !this.IsMuted() + ")");
    return true;
};

FoxyTunesDeezerController.prototype.GetCurrentTrackLength   = function() { throw Components.results.NS_ERROR_NOT_IMPLEMENTED; };
FoxyTunesDeezerController.prototype.GetCurrentTrackPosition = function() { throw Components.results.NS_ERROR_NOT_IMPLEMENTED; };
FoxyTunesDeezerController.prototype.SetCurrentTrackPosition = function() { throw Components.results.NS_ERROR_NOT_IMPLEMENTED; };

FoxyTunesDeezerController.prototype.commandHandlers["GetCurrentTrackTitle"] = function(player, cmd, value) {
    if (!player) return this.getTrackData();

    var title = this.chromeToContentBridge.fireCommand(player.doc, "deezerAudioJSPlayer.getSongTitle();");
    var artist = this.chromeToContentBridge.fireCommand(player.doc, "deezerAudioJSPlayer.getArtistName();");
    var album = this.chromeToContentBridge.fireCommand(player.doc, "deezerAudioJSPlayer.getAlbumTitle();");
    var coverURI = this.chromeToContentBridge.fireCommand(player.doc, "deezerAudioJSPlayer.getCoverURL();");

    return this.getTrackData({"title": title, "artist": artist, "album": album, "coverURI": coverURI, "isVideo": "no"});
};

FoxyTunesDeezerController.prototype.playerIsPlayingInDoc = function(doc) {
    return (this.chromeToContentBridge.fireCommand(doc, "deezerAudioJSPlayer.isPlaying();") == "true");
};

try {
    const NSGetFactory = XPCOMUtils.generateNSGetFactory([FoxyTunesDeezerController]);
} catch(e) {};
