/*
  Copyright (c) 2009 Yahoo! Inc. 
  All Rights Reserved
*/
var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
                     getService(Components.interfaces.mozIJSSubScriptLoader);

if (scriptLoader) {
       scriptLoader.loadSubScript("chrome://foxytunes-components-js/content/players/FoxyTunesJSPlayerBase.js");
}

var playerConfig = new FoxyTunesJSPlayerConfig();
playerConfig.playerURLRegExp = new RegExp("pandora.com|pandorafm.real-ity.com");
playerConfig.playerHomepage = "http://www.pandora.com";
playerConfig.bUseGlobalVolumeController = true;
playerConfig.bUseChromeToContentBridge = false;

function FoxyTunesPandoraController() {
    this.init(playerConfig);
}

FoxyTunesPandoraController.prototype = new FoxyTunesJSPlayerBase();
FoxyTunesPandoraController.prototype.classID = Components.ID("{FBCF974A-4E29-4f1e-B4BC-51953D408523}")

FoxyTunesPandoraController.prototype.defaultCmdHandler = function(player, cmd, value) {
    return this.ShowPlayer();
};

FoxyTunesPandoraController.prototype.GetCurrentTrackLength   = function() { throw Components.results.NS_ERROR_NOT_IMPLEMENTED; };
FoxyTunesPandoraController.prototype.GetCurrentTrackPosition = function() { throw Components.results.NS_ERROR_NOT_IMPLEMENTED; };
FoxyTunesPandoraController.prototype.SetCurrentTrackPosition = function() { throw Components.results.NS_ERROR_NOT_IMPLEMENTED; };
FoxyTunesPandoraController.prototype.IsPlaying               = function() { throw Components.results.NS_ERROR_NOT_IMPLEMENTED; };

FoxyTunesPandoraController.prototype.commandHandlers["GetCurrentTrackTitle"] = function(player, cmd, value) {
    if (!player) return this.getTrackData();

    var listener = player.doc.getElementById('FTEventListener');
    if (!listener) return this.getTrackData();

    var artist = listener.getAttribute('artist');
    var title = listener.getAttribute('song');
   
    if (!title) return this.getTrackData();

    return this.getTrackData({"title": title, "artist": artist, "isVideo": "no"});
};

FoxyTunesPandoraController.prototype.playerFoundInDoc = function(doc) {
    if (!doc.location || !doc.location.href) return false;
    if (!doc.location.href.match(this.playerConfig['playerURLRegExp'])) return false;

    var embed = null;
    if (!doc.embeds) return false;
    for (var iEmbed = 0; iEmbed < doc.embeds.length; iEmbed++) {
        var currEmbed = doc.embeds[iEmbed];
        if (currEmbed.getAttribute('src').match(/pandora.com.*tuner/)) {
            embed = currEmbed;
            break;
        }
    }
    if (!embed) return false;
    return true;
};

FoxyTunesPandoraController.prototype.initPlayerDoc = function(doc) {
    var listener = doc.getElementById('FTEventListener');
    if (listener) return listener;

    var div = doc.createElement('div');
    div.id = 'FTEventListener';
    doc.documentElement.appendChild(div);

    var script = doc.createElement('script');
    script.setAttribute('type', 'text/javascript');
    script.innerHTML = '(function (){ function ftSetCurrentPandoraSong(song, artist) { var div = document.getElementById("FTEventListener"); div.setAttribute("artist", artist); div.setAttribute("song", song); }; function ftRegisterPandoraEvents() { Pandora.setEventHandler("SongPlayed", function(songData) { ftSetCurrentPandoraSong(songData.songName, songData.artistName); }); Pandora.setEventHandler("SongEnded", function(songData) { ftSetCurrentPandoraSong("",  ""); }); } if (typeof(Pandora) == "undefined") { var script=document.createElement("script"); script.setAttribute("src", "http://www.pandora.com/include/PandoraAPIv2.js"); script.setAttribute("type","text/javascript"); script.onload = ftRegisterPandoraEvents; document.getElementsByTagName("head")[0].appendChild(script)} else { ftRegisterPandoraEvents(); }})();';
    doc.getElementsByTagName('head')[0].appendChild(script);
    
    
};

FoxyTunesPandoraController.prototype.playerIsPlayingInDoc = function(doc) {
    return false;
};

try {
    const NSGetFactory = XPCOMUtils.generateNSGetFactory([FoxyTunesPandoraController]);
} catch(e) {};
