/*
  Copyright (c) 2009 Yahoo! Inc. 
  All Rights Reserved
*/
var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
                     getService(Components.interfaces.mozIJSSubScriptLoader);

if (scriptLoader) {
       scriptLoader.loadSubScript("chrome://foxytunes-components-js/content/players/FoxyTunesJSPlayerBase.js");
}

var playerConfig = new FoxyTunesJSPlayerConfig();
playerConfig.playerURLRegExp = new RegExp("mediaplayer.yahoo.com");
playerConfig.playerHomepage = "http://www.foxytunes.com/mediaplayers/yahoo-media-player";
playerConfig.bUseGlobalVolumeController = false;

playerConfig.commandStrMappings["Play"] = "play();";
playerConfig.commandStrMappings["Pause"] = "pause();";
playerConfig.commandStrMappings["Stop"] = "stop();";
playerConfig.commandStrMappings["Next"] = "next();";
playerConfig.commandStrMappings["Previous"] = "previous();";
playerConfig.commandStrMappings["SetVolume"] = "setVolume(%value%);";
playerConfig.commandStrMappings["GetVolume"] = "getVolume();";
playerConfig.commandStrMappings["GetCurrentTrackLength"] = "getTrackDuration();";
playerConfig.commandStrMappings["GetCurrentTrackPosition"] = "getTrackPosition();";

function FoxyTunesYahooMediaPlayerController() {
    this.init(playerConfig);

    this._lastVol = null;
    this._YMP_STATE_PLAYING = 2;
}

FoxyTunesYahooMediaPlayerController.prototype = new FoxyTunesJSPlayerBase();
FoxyTunesYahooMediaPlayerController.prototype.classID = Components.ID("{8A042AE6-CB43-11DC-81AB-072F56D89593}");

FoxyTunesYahooMediaPlayerController.prototype.processCmdInput["SetVolume"] = function(value) { return value/100; };
FoxyTunesYahooMediaPlayerController.prototype.processCmdOutput["GetVolume"] = function(value) { return Math.round(value*100); };

FoxyTunesYahooMediaPlayerController.prototype.defaultCmdHandler = function(player, cmd, value) {
   if (!player) return false;
   var ympCmd = "YAHOO.MediaPlayer." + cmd;
   return this.chromeToContentBridge.fireCommand(player.doc, ympCmd);
};

FoxyTunesYahooMediaPlayerController.prototype.SetCurrentTrackPosition = function() { throw Components.results.NS_ERROR_NOT_IMPLEMENTED; };

FoxyTunesYahooMediaPlayerController.prototype.ToggleMute = function() {
    if (!this._lastVol) {
        this._lastVol = this.GetVolume();
        this.SetVolume(0);
    } else {
        this.SetVolume(this._lastVol);
        this._lastVol = null;
    }
    return true;
};

FoxyTunesYahooMediaPlayerController.prototype.IsMuted = function() {
    if ((this.GetVolume() == 0) && this._lastVol) {
        return true;
    } else {
        return false;
    }
};

FoxyTunesYahooMediaPlayerController.prototype.commandHandlers["GetCurrentTrackTitle"] = function(player, cmd, value) {
    if (!player) return this.getTrackData();

    var getTrackTitle = '';
    getTrackTitle += 'function() {';
    getTrackTitle += 'var trackData = YAHOO.MediaPlayer.getMetaData();';
    getTrackTitle += 'var ftNULL = "FT_NULL";';
    getTrackTitle += 'var res = "";';
    getTrackTitle += 'if (trackData.title) {';
    getTrackTitle += '  res += trackData.title;';
    getTrackTitle += '} else {';
    getTrackTitle += '  res += ftNULL;';
    getTrackTitle += '}';
    getTrackTitle += 'if (trackData.artist) {';
    getTrackTitle += '  res += "@@" + trackData.artist;';
    getTrackTitle += '} else {';
    getTrackTitle += '  res += "@@" + ftNULL;';
    getTrackTitle += '}';
    getTrackTitle += 'if (trackData.album) {';
    getTrackTitle += '  res += "@@" + trackData.album;';
    getTrackTitle += '} else {';
    getTrackTitle += '  res += "@@" + ftNULL;';
    getTrackTitle += '}';
    getTrackTitle += 'return res;';
    getTrackTitle += '}()';

    var getAlbumArt = '';
    getAlbumArt += 'function() {';
    getAlbumArt += 'var trackData = YAHOO.MediaPlayer.getMetaData();';
    getAlbumArt += 'return trackData.albumart;';
    getAlbumArt += '}()';

    var title = this.chromeToContentBridge.fireCommand(player.doc, getTrackTitle); 
    var albumArt = this.chromeToContentBridge.fireCommand(player.doc, getAlbumArt); 

    var ftNULL = "FT_NULL";

    titleArr = title.split('@@');
    var track  = (titleArr[0] != ftNULL) ? titleArr[0] : null;
    var artist = (titleArr[1] != ftNULL) ? titleArr[1] : null;
    var album  = (titleArr[2] != ftNULL) ? titleArr[2] : null;

    return this.getTrackData({"title": track, "artist": artist, "album": album, "coverURI": albumArt, "isVideo": "no"});
};

FoxyTunesYahooMediaPlayerController.prototype.ShowPlayer = function() {
    var player = this.findPlayer();
    if (!player) {
        this.lastWindowAndTab = null;
        this.openPlayer();
        return false;
    }
        
    var lastWindowAndTab = this.getCurrentWindowAndTab();

    if (lastWindowAndTab) {
        if (lastWindowAndTab[1] != this.currentPlayer.tab) {
            this.lastWindowAndTab = lastWindowAndTab;
        }
    } 

    var window  = player.window;
    var browser = player.browser;
    var tab     = player.tab;

    window.focus();
    browser.selectedTab = tab;

    if (!this.getPlayerViewState(player.doc)) {
        this.setPlayerViewState(player.doc, true);
    }

    return true;
};

FoxyTunesYahooMediaPlayerController.prototype.HidePlayer = function() {
    if (!this.currentPlayer) {
        this.currentPlayer = this.findPlayer();
        if (!this.currentPlayer) return;
    }

    var currentWindowAndTab = this.getCurrentWindowAndTab(); 

    // Don't hide if we're not on the player tab
    if (currentWindowAndTab[1] != this.currentPlayer.tab) {
        return false;
    }

    if (!this.lastWindowAndTab) {
        if (this.getPlayerViewState(this.currentPlayer.doc)) {
            this.setPlayerViewState(this.currentPlayer.doc, false);
        }
        return false;
    }

    var lastWindow = this.lastWindowAndTab[0];
    var lastTab = this.lastWindowAndTab[1];

    this.lastWindowAndTab = null;

    try {
        if (lastWindow) lastWindow.focus();
        if (lastWindow && lastTab) { 
            lastWindow.getBrowser().selectedTab = lastTab;
        }     
    } catch (e) {};
    
    return true;
};

FoxyTunesYahooMediaPlayerController.prototype.IsPlayerWindowObscured = function() {
    var player = this.findPlayer();
    if (!player) return true;

    var currentWindowAndTab = this.getCurrentWindowAndTab();
    var currentTab = currentWindowAndTab[1];
    if (currentTab == player.tab) {
        return (this.getPlayerViewState(player.doc)) ? false:true;
    }
         
    return true;
};

FoxyTunesYahooMediaPlayerController.prototype.getPlayerViewState = function(doc) {
    var rc = this.chromeToContentBridge.fireCommand(doc, "YAHOO.MediaPlayer.getPlayerViewState()");

    // Sanity
    if ((rc != 0) && (rc != 1)) rc = 0;

    return parseInt(rc);
};

FoxyTunesYahooMediaPlayerController.prototype.setPlayerViewState = function(doc, bShow) {
    var state = bShow ? 1 : 0;
    this.chromeToContentBridge.fireCommand(doc, "YAHOO.MediaPlayer.setPlayerViewState(" + state + ")");
};

FoxyTunesYahooMediaPlayerController.prototype.playerFoundInDoc = function(doc) {
    var scriptTags = doc.getElementsByTagName("script");
    var bYMPAlreadyInPage = false;
    for (var i=0; i<Math.min(scriptTags.length, 1000); i++) {
        if (!scriptTags[i].hasAttribute("src")) continue;
        if (!scriptTags[i].getAttribute("src").match(this.playerConfig.playerURLRegExp)) continue;
        bYMPAlreadyInPage = true;
        break;
    };
    return bYMPAlreadyInPage;
};

FoxyTunesYahooMediaPlayerController.prototype.newDocHandler = function(window, doc) {
    var me = this;
    doc.addEventListener("FoxyTunesYMPInit", function(event) { me.addPlayerToList(window, doc); }, true);
    doc.addEventListener("GooseInit", function(event) { me.addPlayerToList(window, doc); }, true);
};

FoxyTunesYahooMediaPlayerController.prototype.playerIsPlayingInDoc = function(doc) {
    var playerState = this.chromeToContentBridge.fireCommand(doc, "YAHOO.MediaPlayer.getPlayerState()"); 
    return (playerState == this._YMP_STATE_PLAYING) ? true : false;
};

try {
    const NSGetFactory = XPCOMUtils.generateNSGetFactory([FoxyTunesYahooMediaPlayerController]);
} catch(e) {};
