/*
 * ModuleLoader.js by Alex Sirota, FoxyTunes
 * 
 * Based on:
 *   aboutKitchenSinkModules.js
 *   JavaScript framework for JavaScript-based XPCOM component registration
 *   Mook 2004 / 2005
 *   License: MPL
 */

var KnownComponents = [
    {
		Constructor: 'FoxyTunesService',
		ProgID: "@foxytunes.org/FoxyTunesEngine/FoxyTunesService;1",
		CID: Components.ID("{8AE88EE0-C1A6-4691-B1CC-6370F5F5E158}"),
		Description: "FoxyTunes Service",
        Filename : "chrome://foxytunes-components-js/content/players/FoxyTunesService.js"
	},

	{
		Constructor: 'FoxyTunesPandoraController',
		ProgID: "@foxytunes.org/FoxyTunes/Pandora;1",
		CID: Components.ID("{FBCF974A-4E29-4f1e-B4BC-51953D408523}"),
		Description: "FoxyTunes Pandora Controller",
        Filename : "chrome://foxytunes-components-js/content/players/FoxyTunesPandora.js"
	},

    {
		Constructor: 'FoxyTunesLastFMController',
		ProgID: "@foxytunes.org/FoxyTunes/Last.fm;1",
		CID: Components.ID("{1FE309A9-96BE-4243-9051-8D3877CDD735}"),
		Description: "FoxyTunes Last.fm Controller",
        Filename : "chrome://foxytunes-components-js/content/players/FoxyTunesLastFM.js"
	},
	
	{
		Constructor: 'FoxyTunesRhapsodyController',
		ProgID: "@foxytunes.org/FoxyTunes/Rhapsody;1",
		CID: Components.ID("{A4B65999-9849-4206-A9D4-180039232132}"),
		Description: "FoxyTunes Rhapsody Controller",
        Filename : "chrome://foxytunes-components-js/content/players/FoxyTunesRhapsody.js"
	},

    {
		Constructor: 'FoxyTunesYahooMediaPlayerController',
		ProgID: "@foxytunes.org/FoxyTunes/YahooMediaPlayer;1",
		CID: Components.ID("{8A042AE6-CB43-11DC-81AB-072F56D89593}"),
		Description: "FoxyTunes Yahoo! Media Player Controller",
        Filename : "chrome://foxytunes-components-js/content/players/FoxyTunesYahooMediaPlayer.js"
	},

    {
		Constructor: 'FoxyTunesXBMCController',
		ProgID: "@foxytunes.org/FoxyTunes/XboxMediaCenter;1",
		CID: Components.ID("{35125915-C29D-48f6-85F3-38161D4A781E}"),
		Description: "FoxyTunes Xbox Media Center Controller",
        Filename : "chrome://foxytunes-components-js/content/players/FoxyTunesXBMC.js"
	},

    {
		Constructor: 'FoxyTunesYouTubeController',
		ProgID: "@foxytunes.org/FoxyTunes/YouTube;1",
		CID: Components.ID("{CFB58D38-1597-11DE-A654-78EF55D89593}"),
		Description: "FoxyTunes YouTube Controller",
        Filename : "chrome://foxytunes-components-js/content/players/FoxyTunesYouTube.js"
	},

	{
		Constructor: 'FoxyTunesSongbirdController',
		ProgID: "@foxytunes.org/FoxyTunes/Songbird;1",
		CID: Components.ID("{C6D5E58A-760C-11DD-8CC6-280B56D89593}"),
		Description: "FoxyTunes Songbird Controller",
        Filename : "chrome://foxytunes-components-js/content/players/FoxyTunesSongbird.js"
	},

    {
		Constructor: 'FoxyTunesDeezerController',
		ProgID: "@foxytunes.org/FoxyTunes/Deezer;1",
		CID: Components.ID("{28224D0C-7D54-11DE-9872-546F56D89593}"),
		Description: "FoxyTunes Deezer Controller",
        Filename : "chrome://foxytunes-components-js/content/players/FoxyTunesDeezer.js"
	},

	{
		Constructor: 'FoxyTunesBlipFmController',
		ProgID: "@foxytunes.org/FoxyTunes/Blip.fm;1",
		CID: Components.ID("{55ECB1AA-8209-11DE-BE2D-CE5056D89593}"),
		Description: "FoxyTunes Blip.fm Controller",
        Filename : "chrome://foxytunes-components-js/content/players/FoxyTunesBlipFm.js"
	},

    {
		Constructor: 'FoxyTunesAnonymousInstallStatsService',
		ProgID: "@foxytunes.org/FoxyTunesEngine/FoxyTunesAnonymousInstallStatsService;1",
		CID: Components.ID("{1C8BFC60-8E56-11DD-8175-657D56D89593}"),
		Description: "FoxyTunes Anonymous Install Statistics Service",
        Filename : "chrome://foxytunes-components-js/content/anonymous-stats/FoxyTunesAnonymousInstallStatsService.js"
	},

    {
		Constructor: 'FoxyTunesAnonymousUsageStatsService',
		ProgID: "@foxytunes.org/FoxyTunesEngine/FoxyTunesAnonymousUsageStatsService;1",
		CID: Components.ID("{D1D7021E-D48B-11DE-A140-312A56D89593}"),
		Description: "FoxyTunes Anonymous Usgae Statistics Service",
        Filename : "chrome://foxytunes-components-js/content/anonymous-stats/FoxyTunesAnonymousUsageStatsService.js"
	},


    {
		Constructor: 'FoxytunesMusicUpdatesService',
		ProgID: "@foxytunes.org/FoxyTunesEngine/FoxytunesMusicUpdatesService;1",
		CID: Components.ID("{5679A7CA-FC5A-11DD-AD48-055956D89593}"),
		Description: "FoxyTunes Music Updates Service",
        Filename : "chrome://foxytunes-components-js/content/music-updates/musicUpdatesService.js"
	},

    {
		Constructor: 'MusicUpdatesConsumerLastFm',
		ProgID: "@foxytunes.org/MusicUpdatesConsumer/Last.Fm;1",
		CID: Components.ID("{A67C18CC-FC7B-11DD-AFCA-36E955D89593}"),
		Description: "Music Updates Consumer Last.Fm",
        Filename : "chrome://foxytunes-components-js/content/music-updates/musicUpdatesConsumerLastFm.js"
	},

    {
		Constructor: 'MusicUpdatesConsumerTwitter',
		ProgID: "@foxytunes.org/MusicUpdatesConsumer/Twitter;1",
		CID: Components.ID("{E88F4780-14AD-11DE-AD18-408955D89593}"),
		Description: "Music Updates Consumer Twitter",
        Filename : "chrome://foxytunes-components-js/content/music-updates/musicUpdatesConsumerTwitter.js"
	},

    {
		Constructor: 'MusicUpdatesConsumesFacebook',
		ProgID: "@foxytunes.org/MusicUpdatesConsumer/Facebook;1",
		CID: Components.ID("{F1E2BC78-3027-11DE-87F4-BC5455D89593}"),
		Description: "Music Updates Consumer Facebook",
        Filename : "chrome://foxytunes-components-js/content/music-updates/musicUpdatesConsumesFacebook.js"
	},

    {
		Constructor: 'MusicUpdatesConsumesYahooUpdates',
		ProgID: "@foxytunes.org/MusicUpdatesConsumer/YahooUpdates;1",
		CID: Components.ID("{E0F7F5F0-4C8C-11DE-8DD2-D8D356D89593}"),
		Description: "Music Updates Consumer Yahoo Updates",
        Filename : "chrome://foxytunes-components-js/content/music-updates/musicUpdatesConsumesYahooUpdates.js"
	},

];

var ModuleName = "FoxyTunesJSModule";


/* DO NOT CHANGE ANYTHING BELOW THIS LINE !!! */

function loadExternalScript(url, obj) {
	var loader = Components.classes['@mozilla.org/moz/jssubscript-loader;1']
		.createInstance(Components.interfaces['mozIJSSubScriptLoader']);
	try {
			loader.loadSubScript(url, obj);
	} catch (ex) {
			dump('JavaScript-XPCOM module error:\n');
			dump('While loading external script "' 
				+ url + '":\n');
			dump(ex + '\n');
			try {
				dump('File: ' + ex.filename + '\n');
				dump('Line: ' + ex.lineNumber + '\n');
				if (ex.location) {
					dump('Stack File: ' + ex.location.filename + '\n');
					dump('Stack Line: ' + ex.location.lineNumber + '\n');
					dump('Stack Source: ' + ex.location.sourceLine + '\n');
				}
			} catch (e) {
				// we had problems dumping the error - too bad
				dump('(Error retrieving error location)\n');
			}
			throw(ex);
	}
}

var ftJSModules = {
	_firstTime: true,
	
	registerSelf: function (aComponentManager, aFileSpec, aLocation, aType) {
		var index, info;
		if (this._firstTime) {
			this._firstTime = false;
			throw Components.results['NS_ERROR_FACTORY_REGISTER_AGAIN'];
		}
		aComponentManager = aComponentManager
			.QueryInterface(Components.interfaces['nsIComponentRegistrar']);
		
		// No idea how to do this only for debug builds... :p
		dump("*** Registering " + ModuleName
			+ " components (all right -- a JavaScript module!)\n");
		
		for (index in KnownComponents) {
			var info = KnownComponents[index];
			if ("undefined" == typeof(info.CID) || !(info.CID))
				continue;
			aComponentManager.registerFactoryLocation(
				info.CID,
				info.Description,
				info.ProgID,
				aFileSpec,
				aLocation,
				aType
				);
		}
	},

	getClassObject: function (aComponentManager, aCID, aIID) {
		var index, info;
		for (index in KnownComponents) {
			info = KnownComponents[index];
			if (("undefined" != typeof(info.CID)) && (info.CID) 
			  && (aCID.equals(info.CID)))
				return {
					createInstance: function( aOuter, aIID ) {
						if (aOuter != null)
							throw Components.results['NS_ERROR_NO_AGGREGATION'];
                        if (eval('typeof ' + info.Constructor) == 'undefined') {
                            var obj = {};
                            loadExternalScript(info.Filename, obj); 
                        }
                        
	                    var newObject = (new obj[info.Constructor]);
                        // we can implement a JS XPCOM component w/o QI:
			            return newObject.QueryInterface ? newObject.QueryInterface(aIID) : newObject;  
					},
					lockFactory: function ( aLock ) {
						throw Components.results['NS_ERROR_NOT_IMPLEMENTED'];
					},
					QueryInterface: function( aIID ) {
						if ( aIID.equals(Components.interfaces['nsISupports'])
						  || aIID.equals(Components.interfaces['nsIFactory']))
							return this;
						throw Components.results['NS_ERROR_NO_INTERFACE'];
					}
				};
		}

		if (!aIID.equals(Components.interfaces['nsIFactory']))
			throw Components.results['NS_ERROR_NOT_IMPLEMENTED'];
	
		throw Components.results['NS_ERROR_NO_INTERFACE'];
	},

	canUnload: function (aComponentManager) {
		return true;
	}
};

function NSGetModule( aComponentManager, aFileSpec ) {
	return ftJSModules;
}
